#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ${package}.bean;

import ${package}.model.Group;
import ${package}.model.Role;
import ${package}.service.GroupService;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.inject.Named;
import org.apache.myfaces.extensions.cdi.core.api.scope.conversation.ViewAccessScoped;
import org.conventionsframework.bean.BaseMBean;
import org.conventionsframework.qualifier.PersistentClass;
import org.conventionsframework.qualifier.Service;
import org.primefaces.model.DualListModel;

/**
 *
 * @author rmpestano
 */
@Named
@ViewAccessScoped
@PersistentClass(Group.class)
@Service(name = "groupService", entity = Group.class)
public class GroupMBean extends BaseMBean<Group> implements Serializable{

    private Role roleSelected;
    private DualListModel<Role> groupRoles;

    @PostConstruct
    public void initBean() {
        setCreateMessage(getResourceBundle().getString("group.create.message"));
        setUpdateMessage(getResourceBundle().getString("group.update.message"));
        setDeleteMessage(getResourceBundle().getString("group.delete.message"));
    }

    public void preLoadDialog() {
        //gather user roles to ignore them in role popup
        List<Long> myRoles = new ArrayList<Long>();
        for (Role role : getEntity().getRoles()) {
            myRoles.add(role.getId());
        }
        getPaginator().getFilter().put("groupRoles", myRoles);
        super.initModal(getPaginator().getFilter()); //pass the map as parameter to GroupModalMBean
    }

    public GroupService getGroupService(){
        return (GroupService) getBaseService();
    }
    public Role getRoleSelected() {
        return roleSelected;
    }

    public void setRoleSelected(Role roleSelected) {
        this.roleSelected = roleSelected;
    }

    
    @Override
    public void store() {
        List<Role> roles = new ArrayList<Role>();
        for (Iterator<Role> i = groupRoles.getTarget().iterator(); i.hasNext(); ) {
            roles.add(getBaseService().getEntityManager().find(Role.class, i.next().getId()));
        }
        getEntity().setRoles(roles);
        super.store();
    }

    /**
     *
     * invoked by add/new button
     */
    @Override
    public String afterPrepareInsert() {
        List<Role> source = new ArrayList<Role>();
        List<Role> target = new ArrayList<Role>();
        source.addAll(getGroupService().findAvailableRoles(getEntity()));
        groupRoles = new DualListModel(source, target);
        return null;//keep in the same page
    }

    
    
    /**
     *
     * invoked by edit button
     */
    @Override
    public String afterPrepareUpdate() {
        List<Role> source = new ArrayList<Role>();
        List<Role> target = new ArrayList<Role>();
        target.addAll(getEntity().getRoles());
        source.addAll(getGroupService().findAvailableRoles(getEntity()));
        groupRoles = new DualListModel(source, target);
        return null;//keep in the same page
    }

    public DualListModel getGroupRoles() {
        return groupRoles;
    }

    public void setGroupRoles(DualListModel groupRoles) {
        this.groupRoles = groupRoles;
    }
    
}
