#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ${package}.bean;

import ${package}.model.Group;
import ${package}.model.Role;
import ${package}.model.User;
import java.io.Serializable;
import java.util.ArrayList;
import javax.annotation.PostConstruct;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.inject.Named;
import org.conventionsframework.qualifier.Service;
import org.conventionsframework.qualifier.Type;
import org.conventionsframework.service.BaseService;

/**
 *
 * @author rmpestano Oct 2, 2011 11:48:37 AM
 */
@Named
@ApplicationScoped
public class InitAppBean implements Serializable{
    
    @Inject @Service(type = Type.STATELESS,entity=User.class)
    private BaseService userService;
    

    @PostConstruct
    public void init(){
        if(userService.countAll() == 0){
            final Group groupManager = new Group("Manager");
            final Group groupDev = new Group("Devs");
            final Group groupDevOps = new Group("DevOps");
            final Group groupOperations = new Group("Operations");
            
            Role roleOp = new Role("Operator"); 
            Role roleSystem = new Role("System Engineer"); 
            Role roleArch = new Role("architect"); 
            
            groupDevOps.addRole(roleSystem);
            groupDevOps.addRole(roleArch);
            
            groupOperations.addRole(roleOp);
            groupOperations.addRole(roleSystem);
            
            Role roleAdmin = new Role("Administrator"); 
            
            groupManager.addRole(roleAdmin);
            
            Role roleDev = new Role("Developer"); 
            
            groupDev.addRole(roleDev);
            groupDev.addRole(roleArch);
             
            User userAdmin = new User("admin");
            userAdmin.addGroup(groupManager);
            userAdmin.addGroup(groupDevOps);
            userAdmin.addGroup(groupOperations);
            userAdmin.addGroup(groupDev);
            userService.save(userAdmin);
            
            User op = new User("Operator");
            op.addGroup(groupOperations);
            userService.save(op);
            
            User devOps = new User("DevOps Man");
            devOps.addGroup(groupDevOps);
            userService.save(devOps);
            
            User developer = new User("developer");
            developer.addGroup(groupDev);
            userService.save(developer);
            
            User guest = new User("guest");
            userService.save(guest);
        }
    }

}
