#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ${package}.bean;

import ${package}.model.Group;
import ${package}.model.States;
import ${package}.model.User;
import ${package}.service.UserService;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Inject;
import javax.inject.Named;
import org.apache.myfaces.extensions.cdi.core.api.scope.conversation.ViewAccessScoped;
import org.conventionsframework.bean.StateMBean;
import org.conventionsframework.bean.modal.ModalObserver;
import org.conventionsframework.event.ModalCallback;
import org.conventionsframework.paginator.Paginator;
import org.conventionsframework.qualifier.BeanState;
import org.conventionsframework.qualifier.BeanStates;
import org.conventionsframework.qualifier.PaginatorService;
import org.conventionsframework.qualifier.PersistentClass;
import org.conventionsframework.util.Constants;
import org.conventionsframework.util.MessagesController;

/**
 *
 * @author rmpestano
 */

@Named
@ViewAccessScoped
@PersistentClass(User.class)
@BeanStates({
    @BeanState(beanState=Constants.State.FIND_STATE,title="user.find", callback="${symbol_pound}{userMBean.setFindState}",update=":mainForm:controlPanel"),
    @BeanState(beanState=Constants.State.INSERT_STATE,title="user.new", callback="${symbol_pound}{userMBean.setInsertState}",update=":mainForm:pageControl"),
    @BeanState(beanState=Constants.State.UPDATE_STATE,title="user.edit",callback="${symbol_pound}{userMBean.setUpdateState}",update=":mainForm:pageControl"),
    @BeanState(beanState="manageGroup",title="user.manageGroup",callback="${symbol_pound}{userMBean.setGroupState}",update=":mainForm:pageControl"),
})
public class UserMBean extends StateMBean<User> implements ModalObserver{
    private Group groupSelected;
    
    @Inject @PaginatorService(name="groupService")
    private Paginator<Group> groupPaginator;
    
    public UserService getUserService(){
        return (UserService) super.getBaseService();
    }
    
    //IMPORTANT - @EJB is INCOMPATIBLE with JBoss AS you must use @Inject
    @EJB//use @Inject on JBoss AS and @EJB on Glassfish
    public void setService(UserService userService){
        super.setBaseService(userService);
    }
    
    public void manageGroups(){
        setBeanState(States.MANAGE_GROUP);
        groupPaginator.getFilter().put("currentUser", getEntity().getId());
    }
    
    public boolean isManageGroupState(){
        return States.MANAGE_GROUP.equals(getBeanState());
    }

    public Paginator<Group> getGroupPaginator() {
        return groupPaginator;
    }

    
    @PostConstruct
    public void initBean(){
        setCreateMessage(getResourceBundle().getString("user.create.message"));
        setUpdateMessage(getResourceBundle().getString("user.update.message"));
        setDeleteMessage(getResourceBundle().getString("user.delete.message"));
    }

    

    @Override
    public void modalResponse(@Observes(notifyObserver= Reception.IF_EXISTS)ModalCallback callback) {
        Group[] selectedGroups = (Group[]) callback.getResult();
        if(getEntity().getGroups()== null){
            getEntity().setGroups(new ArrayList<Group>());
        }
            
        if(selectedGroups != null && selectedGroups.length > 0){
            boolean groupAdded = false;
            for (Group group : selectedGroups) {
                if(!getEntity().getGroups().contains(group)){
                    //attach deatached entity
                    getEntity().getGroups().add(getUserService().getEntityManager().find(Group.class, group.getId()));
                    groupAdded = true;
                }
            }
            if(groupAdded){
                getUserService().saveOrUpdate(getEntity());
                MessagesController.addInfo(getResourceBundle().getString("user.groupAdded"));
            }
        }
    }

    public void preLoadDialog(){
        //gather user groups to ignore them in groups popup
        List<Long> myGroups = new ArrayList<Long>();
        for (Group group : getEntity().getGroups()) {
            myGroups.add(group.getId());
        }
        getPaginator().getFilter().put("userGroups", myGroups);
        super.initModal(getPaginator().getFilter()); //pass the map as parameter to GroupModalMBean
    }

    @Override
    public void removeFromList() {
            if(getEntity().getGroups() != null && getEntity().getGroups().contains(groupSelected)){
            getEntity().getGroups().remove(groupSelected);
            MessagesController.addInfo(getResourceBundle().getString("group.info.removed", groupSelected.getName(),getResourceBundle().getString("save")));
        }
    } 

    public Group getGroupSelected() {
        return groupSelected;
    }

    public void setGroupSelected(Group groupSelected) {
        this.groupSelected = groupSelected;
    }

    

     
}
