#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ${package}.security;

import java.util.List;
import javax.faces.context.FacesContext;
import javax.interceptor.Interceptor;
import org.conventionsframework.qualifier.SecurityMethod;
import org.conventionsframework.security.SecurityMethodInterceptor;


@SecurityMethod
@Interceptor
public class MethodSecurityInterceptor extends SecurityMethodInterceptor{

    /**
     * this method is responsible for deciding if current user has permission 
     * to execute a method
     * 
     * @param rolesAllowed roles passed in the method
     * @return true if user has permission, false otherwise
     */
    @Override
    public boolean checkUserPermissions(String[] rolesAllowed) {
        //user role(s) should be extracted from current logged user
        List<String> userRoles = (List<String>) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("userRoles");
        if(userRoles == null || userRoles.isEmpty()){
            return false;
        }
        for (String role : rolesAllowed) {
            if(userRoles.contains(role)){
                return true;
            }
        }
        return false;
    }
    
}
